{
   Program_10_Others.Spin
   if a flag is set Executes various commands 
   
}
CON
  Blinker       = 21
  FlagMask      = %0000_0001   'mask for flag for this cog
  BlinkerScale  = 54           ' 2 80_000_000 for NCO counter
  Offset_1      = 5   'offset for location of 2 byte data buffer    
  Offset_2      = 7   'offset for location of 5 byte data buffer

Var
  long Stacks[50], t
  Long Command,Settings,Sems_Flags 

Obj
  D      : "SerialMirror"
  
PUB Start(CommandAddr,SettingsAddr,Sems_FlagsAddr)
  Command    :=   CommandAddr    'save all passed addresses as     
  Settings   :=   SettingsAddr   'local variables to be used
  Sems_Flags :=   Sems_FlagsAddr 'by all processes
  cogNew(Others,@Stacks[0])      'start the cog 

Pri Others
  Initialization
  repeat
     Process0
     if Not(byte[Sems_Flags][1] & FlagMask) 'if flag not set then no action
        Next                                'required, just loop back                            
     case byte[Command][0]              'execute the command
         1: Set_LEDs
         2: Set_BlinkRate
        66: Action_66
       192: Action_192
     OutputToPST                        'output some info to the PST
     byte[Sems_Flags][1] &= !FlagMask   'clear the flag to signal to Main to proceed

Pri Initialization
  'initialize variables I/O direction etc.
  ctrB[30..26] := %00100          'Set ctrB for "NCO single-ended"
  ctrB[5..0]   := Blinker         'Set ctrB's APIN 
  frqB         := 10*BlinkerScale 'set rate
  dirA[20..16]~~
  dirA[Blinker]~~
  t := cnt                        'initialize timer

Pri Process0
  'can do anything here.
  'but there is nothing to do in this case
  'but could anything that requires polling or updating etc.
  
Pri Set_LEDs
  'set the LEDs on P20..P16 per the parameter byte
  outA[20..16] := Byte[Command][1]

Pri Set_BlinkRate
  'set the blink rate  for P21
  frqB := byte[Command][1] * BlinkerScale 'set rate
  if frqB == 0
     phsB~  'make sure the pin is low if it to be off             

Pri Action_192
  'simulate a command that returns some data in
  '4th and 5th bytes in the normal send buffer
  'for now doing nothing but could do any process here
  'to obtain the bytes 
  byte[Command][Offset_1]   := 4
  byte[Command][Offset_1+1] := 5            

Pri Action_66
  'simulate a command that returns some data in the
  'secondary send buffer. For now it is doing nothing
  'but can do any process here to obtain the data 
  byte[Command][Offset_2]   := 10
  byte[Command][Offset_2+1] := 20            
  byte[Command][Offset_2+2] := 30
  byte[Command][Offset_2+3] := 40            
  byte[Command][Offset_2+4] := 50

Pri OutputToPST
  if Not LockSet(byte[Sems_Flags][2]) 'output some info to the PST
     D.Str(string(13,"Others:"))      'if semaphore acquired
     D.Dec(byte[Command][0])   
     D.Str(string(","))
     D.Dec(byte[Command][1])   
     LockClr(byte[Sems_Flags][2])
           