{
   Ping_01.Spin
   Test of Ping
   Reads the time and sends the value to the PST
}   
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 D_TX     = 30
 D_RX     = 31
 D_BAUD   = 115200
 PngPin   = 4
 
OBJ
  D     : "SerialMirror"
 
PUB Main|x
  D.Start(D_RX,D_TX,0,D_BAUD)
  repeat
     x := Ping(PngPin)
     D.Dec(x) 'send the number
     D.Tx(13) 'carriage return
     waitcnt(clkfreq/100+cnt) 'delay for a bit

Pri Ping(Pin) : MS| x,time[2]
  outA[Pin]~               'set Pin low
  dirA[Pin]~~              'make Pin Output
  outA[Pin]~~              'Set Pin high
  outA[Pin]~               'Set Pin low ( results in a > 2 s pulse)
  dirA[Pin]~               'make Pin Input
  x:=cnt                   'start timing for timeout 
  repeat until inA[Pin]    'wait for Pin to go high
    if cnt-x > clkfreq/100 'with a 10ms time out
      return 0             'if timed out then return 0
  time[0] := cnt           'store Current Counter Value
  waitpeq(0, |< Pin, 0)    'wait For Pin To Go LOW 
  time[1] := cnt           'store New Counter Value
  MS :=||(time[0] - time[1])/(clkfreq / 1_000_000) ' Return Time in s