{
   Program_11_Motors.Spin
   if a flag is set Executes various commands
   relating to motors 
   
}
CON
  FlagMask  = %0000_0010   'mask for flag for this cog
  Offset_1  = 5   'offset for location of 2 byte data buffer    
  Offset_2  = 7   'offset for location of 5 byte data buffer
  MidVal    = 1500
  MinVal    = 1000
  MaxVal    = 2000
  Servo1    = 16
  Servo2    = 17

Var
  long Stacks[50], t
  Long Command,Settings,Sems_Flags 

Obj
  D      : "SerialMirror"
  Servo  : "Servo32V7"
  
PUB Start(CommandAddr,SettingsAddr,Sems_FlagsAddr)
  Command    :=   CommandAddr    'save all passed addresses as     
  Settings   :=   SettingsAddr   'local variables to be used
  Sems_Flags :=   Sems_FlagsAddr 'by all processes
  cogNew(Motors,@Stacks[0])     'start the cog 

Pri Motors
  Initialization
  repeat
     Process0
     if Not(byte[Sems_Flags][1] & FlagMask) 'if flag not set then no action
        Next                                'required, just loop back                            
     case byte[Command][0]                  'execute the command
         0:  StopMotors(0)
         6:  MoveMotors(MinVal,MaxVal) 'forward
         7:  MoveMotors(MaxVal,MinVal) 'back
        12:  MoveMotors(MinVal,MinVal) 'right
        13:  MoveMotors(MaxVal,MaxVal) 'left
     OutputToPST                        'output some info to the PST
     byte[Sems_Flags][1] &= !FlagMask   'clear the flag to signal to Main to proceed

Pri Initialization
  'initialize variables I/O direction etc.
  'none needed here
  t := cnt                        'initialize timer
  Servo.Start

Pri Process0
  'can do anything here.
  'but there is nothing to do in this case
  'but could anything that requires polling or updating etc.
  
Pri StopMotors(wait)
  Servo.Set(Servo1,MidVal)
  Servo.Set(Servo2,MidVal)
  if wait
    waitcnt(cnt+(clkfreq/1_000_000)*50)  'wait 50 microsecs

Pri MoveMotors(Val1,Val2)
  StopMotors(1)     
  Servo.Set(Servo1,Val1)
  Servo.Set(Servo2,Val2)


Pri OutputToPST
  if Not LockSet(byte[Sems_Flags][2]) 'output some info to the PST
     D.Str(string(13,"Motors:"))      'if semaphore acquired
     D.Dec(byte[Command][0])   
     D.Str(string(","))
     D.Dec(byte[Command][1])   
     LockClr(byte[Sems_Flags][2])
           