{
   Program_11_Others.Spin
   if a flag is set Executes various commands 
   
}
CON
  Blinker       = 21
  RCPin1        = 2
  RCPin2        = 3
  PingPin       = 4
  FlagMask      = %0000_0001   'mask for flag for this cog
  BlinkerScale  = 54           ' 2 80_000_000 for NCO counter
  Offset_1      = 5   'offset for loaction of 2 byte data buffer    
  Offset_2      = 7   'offset for location of 5 byte data buffer
Var
  long Stacks[50], t
  Long Command,Settings,Sems_Flags,RCTime[2] 

Obj
  D      : "SerialMirror"
  RC     : "Pots_RCTime"                                
  
PUB Start(CommandAddr,SettingsAddr,Sems_FlagsAddr)
  Command    :=   CommandAddr    'save all passed addresses as     
  Settings   :=   SettingsAddr   'local variables to be used
  Sems_Flags :=   Sems_FlagsAddr 'by all processes
  cogNew(Others,@Stacks[0])      'start the cog 

Pri Others
  Initialization
  repeat
     Process0
     if Not(byte[Sems_Flags][1] & FlagMask) 'if flag not set then no action
        Next                                'required, just loop back                            
     case byte[Command][0]              'execute the command
          1: Set_LEDS
          2: Set_BlinkRate
         66: Read_Pots
        192: Read_Ping
     OutputToPST                        'output some info to the PST
     byte[Sems_Flags][1] &= !FlagMask   'clear the flag to signal to Main to proceed

Pri Initialization
  'initialize variables I/O direction etc.
  ctrA[30..26] := %00100          'Set ctrA for "NCO single-ended"
  ctrA[5..0]   := Blinker         'Set ctrA's APIN 
  frqA         := 10*BlinkerScale 'set rate
  dirA[20..18]~~
  dirA[Blinker]~~
  t := cnt                        'initialize timer

Pri Process0
  'can do anything here.
  'but there is nothing to do in this case
  'but could anything that requires polling or updating etc.
  
Pri Set_LEDs
  'set the LEDs on P20..P18 per the parameter byte
  outA[18..20] := Byte[Command][1]
Pri Set_BlinkRate
  'set the blink rate  for P21
  frqA := byte[Command][1] * BlinkerScale 'set rate
  if frqA == 0
     phsA~  'make sure the pin is low if it to be off             

Pri Read_Ping |x
  'read the Ping time and return its 2 byte value in the
  '4th and 5th bytes of the primary buffer. MSByte first.
  x := Ping(PingPin)
  byte[Command][Offset_1]   := (x >> 8) & $FF
  byte[Command][Offset_1+1] := x & $FF            

Pri Read_Pots
  'Read the two Pots and returns the readings in the
  'secondary send buffer. Use MSByte first for both
  'the 16 bit values
  RC.RCTime(RCPin1,1,@RCTime[0])   'use Pots_RCTime in direct mode ...no cog                                              
  RC.RCTime(RCPin2,1,@RCTime[1])   'to get one-time reading...                                              
  byte[Command][Offset_2]   := (RCTime[0]>>8)& $FF
  byte[Command][Offset_2+1] := RCTime[0] & $FF            
  byte[Command][Offset_2+2] := (RCTime[1]>>8)& $FF
  byte[Command][Offset_2+3] := RCTime[1] & $FF            
  byte[Command][Offset_2+4] := 0

Pri OutputToPST
  if Not LockSet(byte[Sems_Flags][2]) 'output some info to the PST
     D.Str(string(13,"Others:"))      'if semaphore acquired
     D.Dec(byte[Command][0])   
     D.Str(string(","))
     D.Dec(byte[Command][1])   
     LockClr(byte[Sems_Flags][2])

Pri Ping(Pin) : MS| x,time[2]
  outA[Pin]~               'set Pin low
  dirA[Pin]~~              'make Pin Output
  outA[Pin]~~              'Set Pin high
  outA[Pin]~               'Set Pin low ( results in a > 2 s pulse)
  dirA[Pin]~               'make Pin Input
  x:=cnt                   'start timing for timeout 
  repeat until inA[Pin]    'wait for Pin to go high
    if cnt-x > clkfreq/100 'with a 10ms time out
      return 0             'if timed out then return 0
  time[0] := cnt           'store Current Counter Value
  waitpeq(0, |< Pin, 0)    'wait For Pin To Go LOW 
  time[1] := cnt           'store New Counter Value
  MS :=||(time[0] - time[1])/(clkfreq / 1_000_000) ' Return Time in s