{
   Program_11_Reader.Spin
   reads the pushbuttons and sets the top 3 bytes
}
CON
  Blinker    = 22

Var
  long Stacks[50]
  long t, SendBuffer,Settings,Sems_Flags
  byte LocalBytes[3]

Obj
  D      : "SerialMirror"
  
PUB Start(SendBufferAddr,SettingsAddr,Sems_FlagsAddr)
  SendBuffer  := SendBufferAddr   'save all passed addresses as   
  Settings    := SettingsAddr      'local variables to be used     
  Sems_Flags  := Sems_FlagsAddr    'by all processes             
  cogNew(Reader,@Stacks[0])        'start the cog

Pri Reader
  Initialization
  repeat
     Process0
     ReadByte0
     ReadByte1
     ReadByte2
     PutBytesInSendBuffer

Pri Initialization
  'initialize variables I/O direction etc.
  dirA[Blinker]~~
  t := cnt                                 'initialize the timer

Pri Process0
  'can do anything here. That require polling or regular updating
  'For example we are blinking an LED on P22 using a stop watch
  'action with the variable t that hast to be initialized before
  'calling this process for the first time.
  if Long[Settings][0] == 0                'if duration is 0 then off
    outA[Blinker]~
  elseif (cnt-t) => Long[Settings][0]      'blinker time out
    !outA[Blinker]                         'toggle the LED
    t :=cnt                                'reset the timer

Pri ReadByte0
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P5 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[0]:= !inA[5] & $01

Pri ReadByte1
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P6 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[1]:= !inA[6] & $01
  
Pri ReadByte2
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P7 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[2]:= !inA[7] & $01

Pri PutBytesInSendBuffer|i
  if Not LockSet(byte[Sems_Flags][0])   'only set the bytes to send if got semaphore
    repeat i from 0 to 2
      byte[SendBuffer][i] := LocalBytes[i]
    LockClr(byte[Sems_Flags][0])        'clear the semaphore
    'OutputToPST                         'send some info to the PST        

Pri OutputToPST|i
  if Not LockSet(byte[Sems_Flags][2]) 'write debug messages to the PST
    D.Str(string(13,"Reader:"))       '   if semaphore aquired
    repeat i from 0 to 2
       D.Dec(byte[SendBuffer][i])   
       D.Str(string(","))
    LockClr(byte[Sems_Flags][2])
         