{
  Servomotor_05.Spin
  Drives 2 servomotors on P16..P17
  But uses the Servo32V7.Obj
  And interacts with Servomotor_04.BAS to drive both motors
  forward/backwards or to turn right/left
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  RB_TX    = 1
  RB_RX    = 0
  RB_BAUD  = 115200

  Blinker = 23
  MidVal  = 1500
  MinVal  = 1000
  MaxVal  = 2000
  Servo1  = 16
  Servo2  = 17
  
Obj
  RB    : "FullDuplexSerial"
  Servo : "Servo32V7"

PUB Main|t,x
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)      'start the serial driver
  Servo.Start                          'start the object
  dirA[Blinker]~~
  t := cnt
  repeat
     if cnt-t > clkfreq
       !outA[Blinker]
       t := cnt
     x := RB.RxCheck
     if x == -1
        Next
     case x
        0: StopMotors(0)                  'stop     
        1: StopMotors(1)     
           Servo.Set(Servo1,MinVal)       'forward
           Servo.Set(Servo2,MaxVal)
        2: StopMotors(1)     
           Servo.Set(Servo1,MaxVal)       'backward
           Servo.Set(Servo2,MinVal)
        3: StopMotors(1)     
           Servo.Set(Servo1,MinVal)       'right
           Servo.Set(Servo2,MinVal)
        4: StopMotors(1)     
           Servo.Set(Servo1,MaxVal)       'left
           Servo.Set(Servo2,MaxVal)
     RB.Tx(x)     

Pri StopMotors(wait)
  Servo.Set(Servo1,MidVal)
  Servo.Set(Servo2,MidVal)
  if wait
    waitcnt(cnt+(clkfreq/1_000_000)*50)  'wait 50 microsecs