{
   Firmware_Reader_F.Spin
   reads the pushbuttons and sets the top 3 bytes
   Adds the QTI
}
CON
  Blinker    = 22
  QTI_Top    = 10
  QTI_Bottom = 8

Var
  long CogN,Stacks[50]
  long t, SendBuffer,Settings,Sems_Flags
  byte LocalBytes[3]

Obj
  D      : "SerialMirror"
  
PUB Start(SendBufferAddr,SettingsAddr,Sems_FlagsAddr)
  SendBuffer  := SendBufferAddr   'save all passed addresses as   
  Settings    := SettingsAddr      'local variables to be used     
  Sems_Flags  := Sems_FlagsAddr    'by all processes             
  CogN := Result :=cogNew(Reader,@Stacks[0])+1        'start the cog

Pub Stop
  If CogN
     CogStop(CogN~ -1)

Pri Reader
  Initialization
  repeat
     Process0
     ReadByte0
     ReadByte1
     ReadByte2
     PutBytesInSendBuffer

Pri Initialization
  'initialize variables I/O direction etc.
  outA[QTI_Top..QTI_Bottom]~~
  dirA[Blinker]~~
  t := cnt                                 'initialize the timer

Pri Process0
  'can do anything here. That require polling or regular updating
  'For example we are blinking an LED on P22 using a stop watch
  'action with the variable t that hast to be initialized before
  'calling this process for the first time.
  if Long[Settings][0] == 0                'if duration is 0 then off
    outA[Blinker]~
  elseif (cnt-t) => Long[Settings][0]      'blinker time out
    !outA[Blinker]                         'toggle the LED
    t :=cnt                                'reset the timer

Pri ReadByte0
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P5 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[0]:= !inA[5] & %01

Pri ReadByte1
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P6 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[1]:= !inA[7..6] & %11
  
Pri ReadByte2
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P7 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  dirA[QTI_Top..QTI_Bottom]~~                  'turn pins to output
  waitcnt(clkfreq/100_000*23+cnt)              'wait 230 us
  dirA[QTI_Top..QTI_Bottom]~                   'make the pins input
  waitcnt(clkfreq/100_000*23+cnt)              'wait 230 us
  LocalBytes[2]:=inA[QTI_Top..QTI_Bottom]      'read the states and store in byte
  

Pri PutBytesInSendBuffer|i
  if Not LockSet(byte[Sems_Flags][0])   'only set the bytes to send if got semaphore
    repeat i from 0 to 2
      byte[SendBuffer][i] := LocalBytes[i]
    LockClr(byte[Sems_Flags][0])        'clear the semaphore
    'OutputToPST                         'send some info to the PST        

Pri OutputToPST|i
  if Not LockSet(byte[Sems_Flags][2]) 'write debug messages to the PST
    D.Str(string(13,"Reader:"))       '   if semaphore aquired
    repeat i from 0 to 2
       D.Dec(byte[SendBuffer][i])   
       D.Str(string(","))
    LockClr(byte[Sems_Flags][2])
         