//EEPROM_Tester_Extended.Bas
//works with Extended_Protocol_Main.Spin
//works with Extended_Protocol_Main.Spin
//but over the LAN or internet
TCPS_IP = "192.168.0.198" \ TCPS_Port = 50000
tcpc_Connect(TCPS_IP,TCPS_Port)
Port = 0 //change this is as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//-----------------------------------------------------------
Main:
  setcommport Port,br115200
  call SendCommand(5,2) 'print EEPROM params to PST
  call SendCommand(5,3)  'print out RAM params to PST
  print "Reading All EEPROM Params"
  call ReadAllParams(0)  'read all EEPROM
  print "Reading All RAM Params"  
  call ReadAllParams(1)  'read all RAM
  print "Saving RAM params to EEPROM"
  call SendCommand(5,0,s)   'save to EEPROM
  m = "Saving to the EEPROM failed"
  if SendCommand__Result
     if getstrbyte(s,5) then m = "Saving to the EEPROM succeeded"
  endif
  print m
  print "Changing some params"
  call SendCommand(200,250) 'set the P23 brightness
  call SetParameter(211,0)   'no blinking on P22
  call SetParameter(250,1000)
  call SetParameter(253,2000)

  call SendCommand(5,2) 'print EEPROM params to PST
  call SendCommand(5,3) 'print out RAM params to PST
  print "Press any key to proceed"
  waitkey k
  clearscr
  print "Reading All EEPROM Params"
  call ReadAllParams(0)  'read all EEPROM
  print "Reading All RAM Params"  
  call ReadAllParams(1)  'read all RAM

  print "Resetting factory settings and saving to the EEPROM"
  call SendCommand(5,1) 'restore factory settings
  call SendCommand(5,0) 'save to the EEPROM
  call SendCommand(5,1) 'print RAM params to the PST  
  call SendCommand(5,2) 'print EEPROM params to PST

  print "Press any key to proceed"
  waitkey k
  clearscr
  print "Reading All EEPROM Params"
  call ReadAllParams(0)  'read all EEPROM
  print "Reading All RAM Params"  
  call ReadAllParams(1)  'read all RAM

  print "all done"
end
//------------------------------------------
sub SendCommand(C,P,&s)
   //serialout C,P
   //serbytesin 5,s,x
   m = ""
   call TCP_SendCommand(C,P,s,x)
   if x < 5 then m= "Comms Error"
   xystring 500,20,m,spaces(30)  
return (x==5)
//------------------------------------------
sub SetParameter(C,P)
   //serialout C,BuffWrite("",0,P)
   //serbytesin 5,s,x
   TCPC_Send(char(C)+BuffWrite("",0,P))
   call ReadBytes(5,s,x)
return (x==5)
//------------------------------------------
sub ReadAllParams(which)
   //serialout 254,which
   TCPC_Send(char(254)+char(which))
   //serbytesin 4,s,x
   call ReadBytes(4,s,x)
   if x < 4 then  return false
   n = BuffReadI(s,0)
   //serbytesin n*4,s,x
   Remain = n*4+4-length(s)  //number of bytes still not arrived
   call ReadBytes(Remain,ss,x) //read them
   if x < Remain then return false
   s = substring(s,5)+ss //append two buffers remove first 4 bytes from first buffer
   for i=0 to n-1
     print BuffReadI(s,i*4)
   next
   print
return true
//------------------------------------------
sub ReadBytes(n,&s,&x)  
  x=0 \ GetTimeOut T \ T+=150
  t = timer() 
  repeat
    x= TCPC_BuffCount() 
    if x >= n then s = TCPC_Read() \ break
  until timer()-t > T
return
