//3D_Plane_Tester.Bas
//Test program to test the instruments and 3d plane plotting
//without having to have a real compass and accelerometer
//use arrow keys to pitch and roll and Z and X to change heading
Port = 0 //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//---------------------------------------
Main:
  gosub Initialization
  H = 0 \ gX = 0 \ gY = 0 \ gZ = 1
  while true
     if keydown(kc_DArrow) then gX+=.01
     if keydown(kc_UArrow) then gX-=.01
     if keydown(kc_RArrow) then gY+=.01
     if keydown(kc_LArrow) then gY-=.01  
     if KeyDown(Ascii("Z")) then H = limit(H-1,-360,360)
     if KeyDown(Ascii("X")) then H = limit(H+1,-360,360)
     call PlotPlane(gX,gY,gZ,H)
  wend
End
//=================================
Initialization:
  fmta = "#0.0000   " \ fmtb = "  #00     "
  setcommport Port,br115200
  v = 0
  data plane;9,.5,6,1.5,4,1.5
  data plane;0,8.5,-1,8.5,-1,1.5,-4,.5,-5,3.5,-6,3.5
  data plane;-6,-3.5,-5,-3.5,-4,-0.5,-1,-1.5,-1,-8.5,0,-8.5
  data plane;4,-1.5,6,-1.5,9,-0.5,9,.5
  
  data Eye;170,pi(),pi(.30),1550,400,350 //rho,theta,phi,d,Cx,Cy
  dim Plane[maxdim(plane)/2,5]
  mconstant Plane,0
  for i=0 to maxdim(plane)/2 -1
    Plane[i,0] = plane[i*2]
    Plane[i,1] = plane[i*2+1]
  next
  flip on
  AddCheckBox "Mode",630,130,"&Real Mode",1,0
  print "Use arrow keys to pitch and roll and Z and X to change heading"
  savescr
return
//=================================
sub SendCommand(C,P,&s)
  m = ""
  serialout C,P
  serbytesin 5,s,x
  if x < 5 then m= "Comms Error"
  xystring 500,20,m,spaces(30)  
return (x == 5)
//=================================
sub PlotPlane(gX,gY,gZ,H)
  thX = atan2(gX,gZ)-pi(.5) //x-tilt
  thY = atan2(gY,gZ)-Pi(.5) //y-tilt
  mcopy Plane,K  //refresh body coordinates array
  geRotateA K,-thY,1 //rotate around x-axis i.e. Roll
                     //negative to allow for the right hand rule
  geRotateA K,thX,2  //rotate around y-axis i.e. Pitch
  geRotateA K,dtor(-H),3  //rotate around z-axis i.e. Yaw
                          //negative to allow for the right hand rulle
  ge3dto2da K,Eye    //calculated screen coordinates
  for i=1 to maxdim(K)-1  //plot the plane
    line K[i-1,3],K[i-1,4],K[i,3],K[i,4]
  next
  if H < 360 then H+=360
  call DisplayCompass(!GetCheckBox("Mode"),H,600,200) 
  call DisplayAttitude(thX,-thY,200,200)
  flip
  restorescr
return
//=================================


