//Instruments.Bas
//to be used as an #include file in all programs
//that need to display the instruments
//--------------------------------------------------
sub DisplayCompass(Mode,H,x,y,f,t)
   fnt = "Times New Roman"
   if !vType(Mode) then Mode = 0
   Mode = Limit(Mode,0,1)*2-1
   if !vType(H) then H = 0
   if !vType(x) then x = 400 
   if !vType(y) then y = 300
   if !vType(f) then f = 2   
   if !vType(t) then t = 10
   dim xx[2,t*2]
   erectanglewh x-20,y-75,40,35,9,gray
   rectanglewh x-20,y-75,40,35,gray,black
   xyText x-12,y-65,Format(H,"000"),fnt,10,fs_Bold,white,black
   erectanglewh x-t*f*5-t,y-40,2*(t*f*5+t),60,9,gray
   rectanglewh x-t*f*5-t,y-40,2*(t*f*5+t),60,gray,black
   n= H # 5
   for i=0 to t-1
      xx[0,i] = H-n-5*i \ if xx[0,i] < 0 then xx[0,i] += 360
      if xx[0,i] == 360 then xx[0,i] = 0
      xx[1,i] = Mode*f*(n+i*5)
      xx[0,i+t] = H+5-n+5*i \ if xx[0,i+t] == 360 then xx[0,i+t] = 0
      xx[1,i+t] = -Mode*f*(5-n+i*5)
   next
   for i=0 to t*2-1
     l = 5 \ hh = xx[0,i]
     if !(hh#10) then l = 7
     if !(hh #30)
        hh /= 10
        if hh == 0 
           hh = "N"
        elseif hh == 9 
           hh = "E"
        elseif hh == 27 
           hh = "W"
        elseif hh == 18 
           hh = "S"
        endif   
        xytext x-xx[1,i]-5,y-30,hh,fnt,8,fs_Bold,white,black
        l = 10
     endif
     line x-xx[1,i],y-l,x-xx[1,i],y+l,2,white
   next  
   line x,y-36,x,y+15,1,red
return
//-------------------------------------------------
sub DisplayAttitude(Pitch,Roll,Cx,Cy,r,LW,CW)
  if !vType(Pitch) then Pitch = 0
  if !vType(Roll) then Roll = 0
  if !vType(r) then r = 100
  if !vType(Cx) then Cx = 400
  if !vType(Cy) then Cy = 300
  if !vType(LW) then LW = 2
  if !vType(CW) then CW = 10
  //horizon
  T = -Roll-Pitch \ TT = -Roll+Pitch+pi()
  x1 = cartx(r,T) \ y1 = carty(r,T) 
  x2 = cartx(r,TT) \ y2 = carty(r,TT) 
  x3 = (x2+x1)/2 \ y3 = (y2+y1)/2
  Circle Cx-r,Cy-r,Cx+r, Cy+r
  line x1+Cx,y1+Cy,x2+Cx,y2+Cy,LW,red
  //ground and sky
  for i=-3 to 3 step 6
    T1 = -Roll-Pitch+dtor(i) \ TT1 = -Roll+Pitch+pi()-dtor(i)
    x1 = cartx(r,T1) \ y1 = carty(r,T1) 
    x2 = cartx(r,TT1) \ y2 = carty(r,TT1) 
    x4 = (x2+x1)/2 \ y4 = (y2+y1)/2
    j = brown
    if i < 0 then j= lightcyan
    floodfill Cx+x4,Cy+y4,j
  next  
  //ground texture arrays
  if !vType(_DAI_Flag)
    dim DAI_b[0]
    data DAI_b;5,10,20,40,60
    dim DAI_a[0]
    data DAI_a;0,dtor(30),-dtor(180),-dtor(40),dtor(10),-dtor(140)
    _DAI_Flag = true
  endif  
  //horizontal ground texture
  for i=0 to 4
    T1 = -Roll-Pitch+dtor(DAI_b[i]) \ TT1 = -Roll+Pitch+pi()-dtor(DAI_b[i])
    x1 = cartx(r,T1) \ y1 = carty(r,T1) 
    x2 = cartx(r,TT1) \ y2 = carty(r,TT1) 
    line x1+Cx,y1+Cy,x2+Cx,y2+Cy
  next
  //diagonal ground texture
  j=dtor(20) \ i=T+j
  repeat
    x1 = cartx(r,i) \ y1 = carty(r,i)
    line Cx+x3,Cy+y3,Cx+x1,Cy+y1
    i += j
  until abs(i) > abs(TT-j+.2)
  Arc Cx-r,Cy-r,Cx+r, Cy+r,,,CW,gray  //instrument rim
  //roll gradations
  for k=0 to maxdim(DAI_a)-1 step 3
    i = -Roll+DAI_a[k] \ j=DAI_a[k+1]
    TW = CW/2
    if k >=3 then TW = 2
    rr1 = r+TW \ rr2 = r-TW
    repeat
      x1 = cartx(rr1,i) \ y1 = carty(rr1,i)
      x2 = cartx(rr2,i) \ y2 = carty(rr2,i)
      line Cx+x1,Cy+y1,Cx+x2,Cy+y2,2,white
      i -= j
    until i < -Roll+DAI_a[k+2]-.2
  next
  //roll or bank indicator
  for j=-2 to 2 step 4
    i = -dtor(90-j)
    x1 = cartx(r+CW/2,i) \ y1 = carty(r+CW/2,i)
    x2 = cartx(r-CW/2,i) \ y2 = carty(r-CW/2,i)
    line Cx+x1,Cy+y1,Cx+x2,Cy+y2,3,red
  next  
  //small airplane 
  rr = r/10
  circlewh Cx-2,Cy-2,4,4,white
  line Cx,Cy,Cx,Cy+rr-1,2,white
  Arc Cx-rr,Cy-rr,Cx+rr,Cy+rr,pi(),pi(),2,white
  Line Cx-rr,Cy,Cx-4*rr,Cy,2,white
  Line Cx+rr,Cy,Cx+4*rr,Cy,2,white
Return
//--------------------------------------------------
sub Read_H48C(&vRef,&xRef,&yRef,&zRef,&xG,&yG,&zG)
  xRef = 0 \ yRef = 0 \ zRef = 0 
  xG =0 \ yG = 0 \ zG = 0
  if vRef == 0
     call SendCommand(70,1,s) //read vRef
     if !SendCommand__Result then return false
     vRef = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
  endif
  call SendCommand(70,0,s) //read the axes
  if !SendCommand__Result then return false
  xRef = (getstrbyte(s,1) << 4) + (getstrbyte(s,2) >>4)
  yRef = ((getstrbyte(s,2)&0x0F) << 8) + getstrbyte(s,3)
  zRef = (getstrbyte(s,4) << 4) + (getstrbyte(s,5) >> 4)
  xG = (xRef-vRef)*.0022  //convert to g-forces
  yG = (yRef-vRef)*.0022
  zG = (zRef-vRef)*.0022
return true
//--------------------------------------------------
sub mmDistance(Tc,t,&D)
   if !vType(Tc) then Tc = 22.2      //if no temp specified assume 22.2 C
   D = 0.5*t*(331.5 + 0.6* Tc)/1000  //convert time to mm
Return D
//-----------------------------------------
sub TCP_SendCommand(C,P,&s,&n)
  TCPC_Read()                  //read the buffer to clear it
  TCPC_Send(char(C)+char(P))   //send the two bytes
  s = "" \ n=0
  GetTimeOut T \ T += 150      //get the actual timeout limit and add
                               //150 ms to allow for processing
  t=timer()                    //start a timer
  repeat                       //wait for the 5 bytes to arrive with timeout
    if TCPC_BuffCount() != 5 then continue  //if not arrive keep waiting
    s = TCPC_Read() \ n=5     //if arrived get them from the buffer
    break                     //since bytes have arrived then end the loop
  until timer()-t > T         //repeat until timeout
return (n == 5) //return true or false depending on number of arrived bytes
